diff -ruN vdr-1.3.31/i18n.c vdr-1.3.32/i18n.c
--- vdr-1.3.31/i18n.c	2005-08-26 15:39:07.000000000 +0200
+++ vdr-1.3.32/i18n.c	2005-09-10 12:20:48.000000000 +0200
@@ -5527,22 +5536,35 @@
   return n >= 0 ? I18nLanguageCode(n) : Code;
 }
 
-bool I18nIsPreferredLanguage(int *PreferredLanguages, int LanguageIndex, int &OldPreference)
+bool I18nIsPreferredLanguage(int *PreferredLanguages, const char *LanguageCode, int &OldPreference, int *Position)
 {
-  for (int i = 0; i < I18nNumLanguages; i++) {
-      if (PreferredLanguages[i] < 0)
-         break; // the language is not a preferred one
-      if (PreferredLanguages[i] == LanguageIndex) {
-         if (OldPreference < 0 || i < OldPreference) {
-            OldPreference = i;
-            return true;
+  int pos = 1;
+  bool found = false;
+  while (LanguageCode) {
+        int LanguageIndex = I18nLanguageIndex(LanguageCode);
+        for (int i = 0; i < I18nNumLanguages; i++) {
+            if (PreferredLanguages[i] < 0)
+               break; // the language is not a preferred one
+            if (PreferredLanguages[i] == LanguageIndex) {
+               if (OldPreference < 0 || i < OldPreference) {
+                  OldPreference = i;
+                  if (Position)
+                     *Position = pos;
+                  found = true;
+                  break;
+                  }
+               }
             }
-         break;
-         }
-      }
+        if ((LanguageCode = strchr(LanguageCode, '+')) != NULL) {
+           LanguageCode++;
+           pos++;
+           }
+        else if (pos == 1 && Position)
+           *Position = 0;
+        }
   if (OldPreference < 0) {
      OldPreference = I18nNumLanguages; // higher than the maximum possible value
      return true; // if we don't find a preferred one, we take the first one
      }
-  return false;
+  return found;
 }
diff -ruN vdr-1.3.31/i18n.h vdr-1.3.32/i18n.h
--- vdr-1.3.31/i18n.h	2004-11-02 18:21:19.000000000 +0100
+++ vdr-1.3.32/i18n.h	2005-09-09 16:50:35.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: i18n.h 1.14 2004/11/02 17:21:19 kls Exp $
+ * $Id: i18n.h 1.16 2005/09/09 14:50:35 kls Exp $
  */
 
 #ifndef __I18N_H
@@ -22,10 +22,22 @@
 
 const char * const * I18nLanguages(void);
 const char * const * I18nCharSets(void);
-const char * I18nLanguageCode(int Index);
+const char *I18nLanguageCode(int Index);
 int I18nLanguageIndex(const char *Code);
 const char *I18nNormalizeLanguageCode(const char *Code);
-bool I18nIsPreferredLanguage(int *PreferredLanguages, int LanguageIndex, int &OldPreference);
+   ///< Returns a 3 letter language code that may not be zero terminated.
+   ///< If no normalized language code can be found, the given Code is returned.
+   ///< Make sure at most 3 characters are copied when using it!
+bool I18nIsPreferredLanguage(int *PreferredLanguages, const char *LanguageCode, int &OldPreference, int *Position = NULL);
+   ///< Checks the given LanguageCode (which may be something like "eng" or "eng+deu")
+   ///< against the PreferredLanguages and returns true if one is found that has an index
+   ///< smaller than OldPreference (which should be initialized to -1 before the first
+   ///< call to this function in a sequence of checks). If LanguageCode is not any of
+   ///< the PreferredLanguages, and OldPreference is less than zero, OldPreference will
+   ///< be set to a value higher than the highest language index.  If Position is given,
+   ///< it will return 0 if this was a single language code (like "eng"), 1 if it was
+   ///< the first of two language codes (like "eng" out of "eng+deu") and 2 if it was
+   ///< the second one (like "deu" out of ""eng+deu").
 
 #ifdef PLUGIN_NAME_I18N
 #define tr(s)  I18nTranslate(s, PLUGIN_NAME_I18N)
diff -ruN vdr-1.3.31/interface.c vdr-1.3.32/interface.c
--- vdr-1.3.31/interface.c	2004-11-01 15:23:28.000000000 +0100
+++ vdr-1.3.32/interface.c	2005-09-03 11:07:23.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: interface.c 1.68 2004/11/01 14:23:28 kls Exp $
+ * $Id: interface.c 1.69 2005/09/03 09:07:23 kls Exp $
  */
 
 #include "interface.h"
@@ -56,7 +56,7 @@
   time_t timeout = time(NULL) + Seconds;
   for (;;) {
       Key = GetKey();
-      if ((Key != kNone && (RAWKEY(Key) != kOk || RAWKEY(Key) == Key)) || time(NULL) > timeout || interrupted)
+      if (ISRAWKEY(Key) || time(NULL) > timeout || interrupted)
          break;
       }
   if (KeepChar && ISRAWKEY(Key))
diff -ruN vdr-1.3.31/keys.c vdr-1.3.32/keys.c
--- vdr-1.3.31/keys.c	2004-12-27 12:08:34.000000000 +0100
+++ vdr-1.3.32/keys.c	2005-09-03 13:28:34.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: keys.c 1.7 2004/12/27 11:08:34 kls Exp $
+ * $Id: keys.c 1.8 2005/09/03 11:28:34 kls Exp $
  */
 
 #include "keys.h"
@@ -210,7 +210,6 @@
                  }
               macro[n++] = k_Plugin;
               if (n < MAXKEYSINMACRO) {
-                 macro[n] = kOk;
                  plugin = strdup(p + 1);
                  if (!cPluginManager::GetPlugin(plugin)) {
                     esyslog("ERROR: unknown plugin '%s'", plugin);
diff -ruN vdr-1.3.31/libsi/descriptor.c vdr-1.3.32/libsi/descriptor.c
--- vdr-1.3.31/libsi/descriptor.c	2004-10-16 11:51:05.000000000 +0200
+++ vdr-1.3.32/libsi/descriptor.c	2005-09-03 17:16:49.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.c 1.14 2004/10/16 09:51:05 kls Exp $
+ *   $Id: descriptor.c 1.15 2005/09/03 15:16:49 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -655,14 +655,32 @@
 }
 
 void ISO639LanguageDescriptor::Parse() {
-   unsigned int offset=0;
-   data.setPointerAndOffset<const descr_iso_639_language>(s, offset);
+   languageLoop.setData(data+sizeof(descr_iso_639_language), getLength()-sizeof(descr_iso_639_language));
+   
+   //all this is for backwards compatibility only
+   Loop::Iterator it;
+   Language first;
+   if (languageLoop.getNext(first, it)) {
+      languageCode[0]=first.languageCode[0];
+      languageCode[1]=first.languageCode[1];
+      languageCode[2]=first.languageCode[2];
+      languageCode[3]=0;
+   } else
+      languageCode[0]=0;
+}
+
+void ISO639LanguageDescriptor::Language::Parse() {
+   s=data.getData<const descr_iso_639_language_loop>();
    languageCode[0]=s->lang_code1;
    languageCode[1]=s->lang_code2;
    languageCode[2]=s->lang_code3;
    languageCode[3]=0;
 }
 
+AudioType ISO639LanguageDescriptor::Language::getAudioType() {
+   return (AudioType)s->audio_type;
+}
+
 void PDCDescriptor::Parse() {
    unsigned int offset=0;
    data.setPointerAndOffset<const descr_pdc>(s, offset);
diff -ruN vdr-1.3.31/libsi/descriptor.h vdr-1.3.32/libsi/descriptor.h
--- vdr-1.3.31/libsi/descriptor.h	2005-05-08 16:08:19.000000000 +0200
+++ vdr-1.3.32/libsi/descriptor.h	2005-09-03 17:17:35.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.h 1.12 2005/05/08 14:08:19 kls Exp $
+ *   $Id: descriptor.h 1.13 2005/09/03 15:17:35 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -392,7 +392,18 @@
 
 class ISO639LanguageDescriptor : public Descriptor {
 public:
-   char languageCode[4];
+   char languageCode[4]; //for backwards compatibility
+   class Language : public LoopElement {
+   public:
+      virtual int getLength() { return sizeof(descr_iso_639_language_loop); }
+      char languageCode[4];
+      AudioType getAudioType();
+   protected:
+      virtual void Parse();
+   private:
+      const descr_iso_639_language_loop *s;
+   };
+   StructureLoop<Language> languageLoop;
 protected:
    virtual void Parse();
 private:
diff -ruN vdr-1.3.31/libsi/headers.h vdr-1.3.32/libsi/headers.h
--- vdr-1.3.31/libsi/headers.h	2004-02-22 12:12:46.000000000 +0100
+++ vdr-1.3.32/libsi/headers.h	2005-09-03 17:18:16.000000000 +0200
@@ -10,7 +10,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: headers.h 1.4 2004/02/22 11:12:46 kls Exp $
+ *   $Id: headers.h 1.5 2005/09/03 15:18:16 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -821,9 +821,13 @@
 struct descr_iso_639_language {
    u_char descriptor_tag                         :8;
    u_char descriptor_length                      :8;
+};
+
+struct descr_iso_639_language_loop {
    u_char lang_code1                             :8;
    u_char lang_code2                             :8;
    u_char lang_code3                             :8;
+   u_char audio_type                             :8;
 };
 
 /* 0x13 carousel_identifier_descriptor */
diff -ruN vdr-1.3.31/libsi/si.h vdr-1.3.32/libsi/si.h
--- vdr-1.3.31/libsi/si.h	2004-10-16 11:58:10.000000000 +0200
+++ vdr-1.3.32/libsi/si.h	2005-09-03 17:19:00.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: si.h 1.11 2004/10/16 09:58:10 kls Exp $
+ *   $Id: si.h 1.12 2005/09/03 15:19:00 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -166,6 +166,12 @@
                    LinkageTypeTSContainingSsuBatOrNit = 0x0A
                  };
 
+enum AudioType { AudioTypeUndefined = 0x00,
+                 AudioTypeCleanEffects = 0x01,
+                 AudioTypeHearingImpaired = 0x02,
+                 AudioTypeVisualImpairedCommentary = 0x03
+               };
+
 /* Some principles:
    - Objects that return references to other objects contained in their data must make sure
      that the returned objects have been parsed.
diff -ruN vdr-1.3.31/lirc.c vdr-1.3.32/lirc.c
--- vdr-1.3.31/lirc.c	2005-08-15 14:28:10.000000000 +0200
+++ vdr-1.3.32/lirc.c	2005-09-02 14:51:35.000000000 +0200
@@ -6,7 +6,7 @@
  *
  * LIRC support added by Carsten Koch <Carsten.Koch@icem.de>  2000-06-16.
  *
- * $Id: lirc.c 1.12 2005/08/15 12:28:10 kls Exp $
+ * $Id: lirc.c 1.13 2005/09/02 12:51:35 kls Exp $
  */
 
 #include "lirc.h"
@@ -76,7 +76,10 @@
         if (ready && ret > 21) {
            int count;
            char KeyName[LIRC_KEY_BUF];
-           sscanf(buf, "%*x %x %29s", &count, KeyName); // '29' in '%29s' is LIRC_KEY_BUF-1!
+           if (sscanf(buf, "%*x %x %29s", &count, KeyName) != 2) { // '29' in '%29s' is LIRC_KEY_BUF-1!
+              esyslog("ERROR: unparseable lirc command: %s", buf);
+              continue;
+              }
            if (count == 0) {
               if (strcmp(KeyName, LastKeyName) == 0 && FirstTime.Elapsed() < KEYPRESSDELAY)
                  continue; // skip keys coming in too fast
diff -ruN vdr-1.3.31/menu.c vdr-1.3.32/menu.c
--- vdr-1.3.31/menu.c	2005-08-27 11:37:23.000000000 +0200
+++ vdr-1.3.32/menu.c	2005-09-03 13:42:27.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 1.357 2005/08/27 09:37:23 kls Exp $
+ * $Id: menu.c 1.359 2005/09/03 11:42:27 kls Exp $
  */
 
 #include "menu.h"
@@ -29,7 +29,6 @@
 #include "transfer.h"
 #include "videodir.h"
 
-#define MENUTIMEOUT     120 // seconds
 #define MAXWAIT4EPGINFO   3 // seconds
 #define MODETIMEOUT       3 // seconds
 
@@ -1300,7 +1299,6 @@
   Add(new cOsdItem(ciMenu->BottomText()));
   Display();
   dsyslog("CAM: Menu - %s", ciMenu->TitleText());
-  lastActivity = time(NULL);
 }
 
 cMenuCam::~cMenuCam()
@@ -1329,10 +1327,6 @@
        default: break;
        }
      }
-  if (Key != kNone)
-     lastActivity = time(NULL);
-  else if (time(NULL) - lastActivity > MENUTIMEOUT)
-     state = osEnd;
   return state;
 }
 
@@ -1350,7 +1344,6 @@
   SetTitle(ciEnquiry->Text() ? ciEnquiry->Text() : "CAM");
   Add(new cMenuEditNumItem("Input", input, Length, ciEnquiry->Blind()));
   Display();
-  lastActivity = time(NULL);
 }
 
 cMenuCamEnquiry::~cMenuCamEnquiry()
@@ -1379,10 +1372,6 @@
        default: break;
        }
      }
-  if (Key != kNone)
-     lastActivity = time(NULL);
-  else if (time(NULL) - lastActivity > MENUTIMEOUT)
-     state = osEnd;
   return state;
 }
 
@@ -2402,11 +2391,11 @@
 
 cOsdObject *cMenuMain::pluginOsdObject = NULL;
 
-cMenuMain::cMenuMain(bool Replaying, eOSState State, const char *Plugin)
+cMenuMain::cMenuMain(bool Replaying, eOSState State)
 :cOsdMenu("")
 {
   replaying = Replaying;
-  Set(Plugin);
+  Set();
 
   // Initial submenus:
 
@@ -2417,7 +2406,6 @@
     case osRecordings: AddSubMenu(new cMenuRecordings(NULL, 0, true)); break;
     case osSetup:      AddSubMenu(new cMenuSetup); break;
     case osCommands:   AddSubMenu(new cMenuCommands(tr("Commands"), &Commands)); break;
-    case osPlugin:     break; // the actual work is done in Set()
     default: break;
     }
 }
@@ -2429,7 +2417,7 @@
   return o;
 }
 
-void cMenuMain::Set(const char *Plugin)
+void cMenuMain::Set(void)
 {
   Clear();
   //XXX //SetTitle("VDR"); // this is done below, including disk usage
@@ -2463,7 +2451,7 @@
       if (p) {
          const char *item = p->MainMenuEntry();
          if (item)
-            Add(new cMenuPluginItem(hk(item), i), Plugin && strcmp(Plugin, p->Name()) == 0);
+            Add(new cMenuPluginItem(hk(item), i));
          }
       else
          break;
@@ -2506,7 +2494,6 @@
 
   SetHelp(!replaying ? tr("Record") : NULL, tr("Audio"), replaying ? NULL : tr("Pause"), replaying ? tr("Button$Stop") : cReplayControl::LastReplayed() ? tr("Resume") : NULL);
   Display();
-  lastActivity = time(NULL);
 }
 
 eOSState cMenuMain::ProcessKey(eKeys Key)
@@ -2579,15 +2566,12 @@
                }
     }
   if (Key != kNone) {
-     lastActivity = time(NULL);
      if (Setup.OSDLanguage != osdLanguage) {
         Set();
         if (!HasSubMenu())
            Display();
         }
      }
-  else if (time(NULL) - lastActivity > MENUTIMEOUT)
-     state = osEnd;
   return state;
 }
 
diff -ruN vdr-1.3.31/menu.h vdr-1.3.32/menu.h
--- vdr-1.3.31/menu.h	2005-08-27 11:37:33.000000000 +0200
+++ vdr-1.3.32/menu.h	2005-09-03 13:41:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.h 1.71 2005/08/27 09:37:33 kls Exp $
+ * $Id: menu.h 1.73 2005/09/03 11:41:41 kls Exp $
  */
 
 #ifndef __MENU_H
@@ -55,12 +55,11 @@
 
 class cMenuMain : public cOsdMenu {
 private:
-  time_t lastActivity;
   bool replaying;
   static cOsdObject *pluginOsdObject;
-  void Set(const char *Plugin = NULL);
+  void Set(void);
 public:
-  cMenuMain(bool Replaying, eOSState State = osUnknown, const char *Plugin = NULL);
+  cMenuMain(bool Replaying, eOSState State = osUnknown);
   virtual eOSState ProcessKey(eKeys Key);
   static cOsdObject *PluginOsdObject(void);
   };
@@ -120,7 +119,6 @@
 class cMenuCam : public cOsdMenu {
 private:
   cCiMenu *ciMenu;
-  time_t lastActivity;
   bool selected;
   eOSState Select(void);
 public:
@@ -132,7 +130,6 @@
 class cMenuCamEnquiry : public cOsdMenu {
 private:
   cCiEnquiry *ciEnquiry;
-  time_t lastActivity;
   char *input;
   bool replied;
   eOSState Reply(void);
diff -ruN vdr-1.3.31/pat.c vdr-1.3.32/pat.c
--- vdr-1.3.31/pat.c	2005-08-06 14:23:51.000000000 +0200
+++ vdr-1.3.32/pat.c	2005-09-04 16:32:39.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.c 1.13 2005/08/06 12:23:51 kls Exp $
+ * $Id: pat.c 1.14 2005/09/04 14:32:39 kls Exp $
  */
 
 #include "pat.h"
@@ -326,8 +326,8 @@
         int Ppid = pmt.getPCRPid();
         int Apids[MAXAPIDS + 1] = { 0 }; // these lists are zero-terminated
         int Dpids[MAXDPIDS + 1] = { 0 };
-        char ALangs[MAXAPIDS][4] = { "" };
-        char DLangs[MAXDPIDS][4] = { "" };
+        char ALangs[MAXAPIDS][MAXLANGCODE2] = { "" };
+        char DLangs[MAXDPIDS][MAXLANGCODE2] = { "" };
         int Tpid = 0;
         int NumApids = 0;
         int NumDpids = 0;
@@ -347,10 +347,19 @@
                              switch (d->getDescriptorTag()) {
                                case SI::ISO639LanguageDescriptorTag: {
                                     SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
-                                    if (*ld->languageCode != '-') { // some use "---" to indicate "none"
-                                       strn0cpy(ALangs[NumApids], I18nNormalizeLanguageCode(ld->languageCode), 4);
-                                       ALangs[NumApids][4] = 0;
-                                       }
+                                    SI::ISO639LanguageDescriptor::Language l;
+                                    char *s = ALangs[NumApids];
+                                    int n = 0;
+                                    for (SI::Loop::Iterator it; ld->languageLoop.getNext(l, it); ) {
+                                        if (*ld->languageCode != '-') { // some use "---" to indicate "none"
+                                           if (n > 0)
+                                              *s++ = '+';
+                                           strn0cpy(s, I18nNormalizeLanguageCode(l.languageCode), MAXLANGCODE1);
+                                           s += strlen(s);
+                                           if (n++ > 1)
+                                              break;
+                                           }
+                                        }
                                     }
                                     break;
                                default: ;
@@ -366,7 +375,7 @@
               //XXX case 8: // STREAMTYPE_13818_DSMCC
                       {
                       int dpid = 0;
-                      char lang[4] = { 0 };
+                      char lang[MAXLANGCODE1] = { 0 };
                       SI::Descriptor *d;
                       for (SI::Loop::Iterator it; (d = stream.streamDescriptors.getNext(it)); ) {
                           switch (d->getDescriptorTag()) {
@@ -378,7 +387,7 @@
                                  break;
                             case SI::ISO639LanguageDescriptorTag: {
                                  SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
-                                 strn0cpy(lang, I18nNormalizeLanguageCode(ld->languageCode), 4);
+                                 strn0cpy(lang, I18nNormalizeLanguageCode(ld->languageCode), MAXLANGCODE1);
                                  }
                                  break;
                             default: ;
@@ -388,7 +397,7 @@
                       if (dpid) {
                          if (NumDpids < MAXDPIDS) {
                             Dpids[NumDpids] = dpid;
-                            strn0cpy(DLangs[NumDpids], lang, 4);
+                            strn0cpy(DLangs[NumDpids], lang, MAXLANGCODE1);
                             NumDpids++;
                             }
                          }
diff -ruN vdr-1.3.31/recording.c vdr-1.3.32/recording.c
--- vdr-1.3.31/recording.c	2005-08-13 16:00:48.000000000 +0200
+++ vdr-1.3.32/recording.c	2005-09-10 14:36:48.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 1.111 2005/08/13 14:00:48 kls Exp $
+ * $Id: recording.c 1.113 2005/09/10 12:36:48 kls Exp $
  */
 
 #include "recording.h"
@@ -36,15 +36,8 @@
 #define DATAFORMAT   "%4d-%02d-%02d.%02d:%02d.%02d.%02d" RECEXT
 #define NAMEFORMAT   "%s/%s/" DATAFORMAT
 */
-// start of implementation for brain dead systems
 #define DATAFORMAT   "%4d-%02d-%02d.%02d%*c%02d.%02d.%02d" RECEXT
-#ifdef VFAT
-#define nameFORMAT   "%4d-%02d-%02d.%02d.%02d.%02d.%02d" RECEXT
-#else
-#define nameFORMAT   "%4d-%02d-%02d.%02d:%02d.%02d.%02d" RECEXT
-#endif
-#define NAMEFORMAT   "%s/%s/" nameFORMAT
-// end of implementation for brain dead systems
+#define NAMEFORMAT   "%s/%s/" "%4d-%02d-%02d.%02d.%02d.%02d.%02d" RECEXT
 
 #define RESUMEFILESUFFIX  "/resume%s%s.vdr"
 #ifdef SUMMARYFALLBACK
@@ -65,6 +58,8 @@
 
 #define MAX_SUBTITLE_LENGTH  40
 
+bool VfatFileSystem = false;
+
 void RemoveDeletedRecordings(void)
 {
   static time_t LastRemoveCheck = 0;
@@ -297,79 +292,80 @@
 {
   char *p = s;
   while (*p) {
-#ifdef VFAT
-        // The VFAT file system can't handle all characters, so we
-        // have to take extra efforts to encode/decode them:
-        if (ToFileSystem) {
-           switch (*p) {
-                  // characters that can be used "as is":
-                  case '!':
-                  case '@':
-                  case '$':
-                  case '%':
-                  case '&':
-                  case '(':
-                  case ')':
-                  case '+':
-                  case ',':
-                  case '-':
-                  case ';':
-                  case '=':
-                  case '0' ... '9':
-                  case 'a' ... 'z':
-                  case 'A' ... 'Z':
-                  case 'ä': case 'Ä':
-                  case 'ö': case 'Ö':
-                  case 'ü': case 'Ü':
-                  case 'ß':
-                       break;
-                  // characters that can be mapped to other characters:
-                  case ' ': *p = '_'; break;
-                  case '~': *p = '/'; break;
-                  // characters that have to be encoded:
-                  default:
-                    if (*p != '.' || !*(p + 1) || *(p + 1) == '~') { // Windows can't handle '.' at the end of directory names
-                       int l = p - s;
-                       s = (char *)realloc(s, strlen(s) + 10);
-                       p = s + l;
-                       char buf[4];
-                       sprintf(buf, "#%02X", (unsigned char)*p);
-                       memmove(p + 2, p, strlen(p) + 1);
-                       strncpy(p, buf, 3);
-                       p += 2;
-                       }
-                  }
+        if (VfatFileSystem) {
+           // The VFAT file system can't handle all characters, so we
+           // have to take extra efforts to encode/decode them:
+           if (ToFileSystem) {
+              switch (*p) {
+                     // characters that can be used "as is":
+                     case '!':
+                     case '@':
+                     case '$':
+                     case '%':
+                     case '&':
+                     case '(':
+                     case ')':
+                     case '+':
+                     case ',':
+                     case '-':
+                     case ';':
+                     case '=':
+                     case '0' ... '9':
+                     case 'a' ... 'z':
+                     case 'A' ... 'Z':
+                     case 'ä': case 'Ä':
+                     case 'ö': case 'Ö':
+                     case 'ü': case 'Ü':
+                     case 'ß':
+                          break;
+                     // characters that can be mapped to other characters:
+                     case ' ': *p = '_'; break;
+                     case '~': *p = '/'; break;
+                     // characters that have to be encoded:
+                     default:
+                       if (*p != '.' || !*(p + 1) || *(p + 1) == '~') { // Windows can't handle '.' at the end of directory names
+                          int l = p - s;
+                          s = (char *)realloc(s, strlen(s) + 10);
+                          p = s + l;
+                          char buf[4];
+                          sprintf(buf, "#%02X", (unsigned char)*p);
+                          memmove(p + 2, p, strlen(p) + 1);
+                          strncpy(p, buf, 3);
+                          p += 2;
+                          }
+                     }
+              }
+           else {
+              switch (*p) {
+                // mapped characters:
+                case '_': *p = ' '; break;
+                case '/': *p = '~'; break;
+                // encodes characters:
+                case '#': {
+                     if (strlen(p) > 2) {
+                        char buf[3];
+                        sprintf(buf, "%c%c", *(p + 1), *(p + 2));
+                        unsigned char c = strtol(buf, NULL, 16);
+                        *p = c;
+                        memmove(p + 1, p + 3, strlen(p) - 2);
+                        }
+                     }
+                     break;
+                // backwards compatibility:
+                case '\x01': *p = '\''; break;
+                case '\x02': *p = '/';  break;
+                case '\x03': *p = ':';  break;
+                }
+              }
            }
         else {
-           switch (*p) {
-             // mapped characters:
-             case '_': *p = ' '; break;
-             case '/': *p = '~'; break;
-             // encodes characters:
-             case '#': {
-                  if (strlen(p) > 2) {
-                     char buf[3];
-                     sprintf(buf, "%c%c", *(p + 1), *(p + 2));
-                     unsigned char c = strtol(buf, NULL, 16);
-                     *p = c;
-                     memmove(p + 1, p + 3, strlen(p) - 2);
-                     }
-                  }
+           for (struct tCharExchange *ce = CharExchange; ce->a && ce->b; ce++) {
+               if (*p == (ToFileSystem ? ce->a : ce->b)) {
+                  *p = ToFileSystem ? ce->b : ce->a;
                   break;
-             // backwards compatibility:
-             case '\x01': *p = '\''; break;
-             case '\x02': *p = '/';  break;
-             case '\x03': *p = ':';  break;
-             }
-           }
-#else
-        for (struct tCharExchange *ce = CharExchange; ce->a && ce->b; ce++) {
-            if (*p == (ToFileSystem ? ce->a : ce->b)) {
-               *p = ToFileSystem ? ce->b : ce->a;
-               break;
+                  }
                }
-            }
-#endif
+           }
         p++;
         }
   return s;
@@ -500,6 +496,20 @@
               data[2] = data[1];
               data[1] = NULL;
               }
+           else if (line == 2) {
+              // if line 1 is too long, it can't be the short text,
+              // so assume the short text is missing and concatenate
+              // line 1 and line 2 to be the long text:
+              int len = strlen(data[1]);
+              if (len > 80) { 
+                 data[1] = (char *)realloc(data[1], len + 1 + strlen(data[2]) + 1);
+                 strcat(data[1], "\n");
+                 strcat(data[1], data[2]);
+                 free(data[2]);
+                 data[2] = data[1];
+                 data[1] = NULL;
+                 }
+              }
            info->SetData(data[0], data[1], data[2]);
            for (int i = 0; i < 3; i ++)
                free(data[i]);
diff -ruN vdr-1.3.31/recording.h vdr-1.3.32/recording.h
--- vdr-1.3.31/recording.h	2005-08-13 16:09:50.000000000 +0200
+++ vdr-1.3.32/recording.h	2005-09-03 15:04:41.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 1.39 2005/08/13 14:09:50 kls Exp $
+ * $Id: recording.h 1.40 2005/09/03 13:04:41 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -18,6 +18,8 @@
 #include "timers.h"
 #include "tools.h"
 
+extern bool VfatFileSystem;
+
 void RemoveDeletedRecordings(void);
 void AssertFreeDiskSpace(int Priority = 0);
      ///< The special Priority value -1 means that we shall get rid of any
diff -ruN vdr-1.3.31/remote.c vdr-1.3.32/remote.c
--- vdr-1.3.31/remote.c	2005-08-14 12:53:55.000000000 +0200
+++ vdr-1.3.32/remote.c	2005-09-03 14:29:48.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.c 1.44 2005/08/14 10:53:55 kls Exp $
+ * $Id: remote.c 1.45 2005/09/03 12:29:48 kls Exp $
  */
 
 #include "remote.h"
@@ -143,6 +143,12 @@
   return false;
 }
 
+void cRemote::CallPlugin(const char *Plugin)
+{
+  plugin = Plugin;
+  Put(k_Plugin);
+}
+
 bool cRemote::HasKeys(void)
 {
   cMutexLock MutexLock(&mutex);
diff -ruN vdr-1.3.31/remote.h vdr-1.3.32/remote.h
--- vdr-1.3.31/remote.h	2005-08-13 13:28:10.000000000 +0200
+++ vdr-1.3.32/remote.h	2005-09-03 14:28:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remote.h 1.30 2005/08/13 11:28:10 kls Exp $
+ * $Id: remote.h 1.31 2005/09/03 12:28:42 kls Exp $
  */
 
 #ifndef __REMOTE_H
@@ -44,6 +44,10 @@
   static void Clear(void);
   static bool Put(eKeys Key, bool AtFront = false);
   static bool PutMacro(eKeys Key);
+  static void CallPlugin(const char *Plugin);
+      ///< Initiates calling the given plugin's main menu function.
+      ///< The Plugin parameter is the name of the plugin, and must be
+      ///< a static string.
   static const char *GetPlugin(void) { return plugin; }
   static bool HasKeys(void);
   static eKeys Get(int WaitMs = 1000, char **UnknownCode = NULL);
